function RBH_Commands(args)  
   local s,e,cmd,arg1,arg2,arg3,arg4 = string.find(args,"(%a*)%s?([.?%a%d]*)%s?([.?%a%d]*)%s?([.?%a%d-?]*)%s?([.?%a%d-?]*)")    
   
   --debug
   if cmd == "debug" then
      if arg1 == "on" then
         RBH_Config["debug"] = true
         RBH_LargessMessage("RBH: debug on")
      elseif arg1 == "off" then
         RBH_Config["debug"] = false
         RBH_LargessMessage("RBH: debug off")
      end    

    --show the GUI
    elseif cmd == "show" then
        RBH_ToggleHitList()
        
   --set default channel
   elseif cmd == "channel" then 
      if arg1 == "guild" then
         RBH_Config["channel"] = "GUILD"
      elseif arg1 == "party" then
         RBH_Config["channel"] = "PARTY"
      elseif arg1 == "officer" then
         RBH_Config["channel"] = "OFFICER"
      elseif arg1 == "private" then
         RBH_Config["channel"] = "PRIVATE"
      end
      
   --list hit list
   elseif cmd == "list" then
      RBH_DisplayList() 
  
   --place a bounty
   
   elseif cmd == "bounty" then
      local name, realm = UnitFullName("target")     
      if (realm == nil) then
        realm = GetRealmName()
      end   
      RBH_AddBounty(name, realm)
      
   --resync hit list
   elseif cmd == "sync" then
      RBH_SendAddonMessageToNetwork("ALERT","RBH_HL_SYNC_REQ", "");         
      
   --clear hit list
   elseif cmd == "clear" then
      if arg1 == "bounties" then
         RBH_HitList = {}
      elseif arg1 == "intel" then
         RBH_Intel = {}
      elseif arg1 == "all" then
         RBH_HitList = {}
         RBH_Intel = {}
      end   
      
   --largess commands
   elseif cmd == "largess" then
      if arg1 == "" then
         RBH_LargessMessage("Your current guild Largess is "..RBH_CopperToGold(RBH_Largess))
      elseif arg1 == "report" then
         RBH_GuildLargessReport()
      elseif arg1 == "set" then
         RBH_SetLargess(arg2,arg3)
      elseif arg1 == "mod" then
         RBH_ModLargess(arg2,arg3)
      end   
      
   --audit commands
   elseif cmd == "audit" then
      if arg1 == "reset" then
         --RBH_AuditData = nil
      elseif arg1 == "print" then
         --RBH_AuditPrint()
      elseif arg1 == "" then 
         RBH_AuditPrep()         
      --RBH_DoAudit()
      elseif arg1 == "init" then
         --RBH_AuditInit()
      elseif arg1 == "load" then
         --RBH_AuditLoad()
      elseif arg1 == "save" then
         --RBH_AuditSave()
      elseif arg1 == "bounties" then
         RBH_AuditInit()
         RBH_AuditLoad()
         RBH_AuditBounties()
         RBH_AuditSave()
     elseif arg1 == "list" then
        RBH_AuditHistoryList()
     elseif arg1 == "clear" then        
        RBH_ClearAuditHistory()
     end      
   
   --intel commands
   elseif cmd == "intel" then
      if arg1 == "post" then
         RBH_IntelPost()
      elseif arg1 == "spy" then
         RBH_IntelSpy()
      elseif arg1 == "report" then
         RBH_IntelReport()     
      end   
   
   --version
   elseif cmd == "version" then
      RBH_LargessMessage("Realm Bounty Hunter v"..RBH_VERSION);
     
    --set UI scale
    elseif cmd == "scale" then
        if arg1 ~= nil then
            RBH_Config["scale"] = arg1
            RBH_HitListFrame:SetScale(arg1)
        end   
    
     --get a list of RBH users
    elseif cmd == "users" then
        RBH_LargessMessage("RBH users...")
        RBH_SendAddonMessageToNetwork("ALERT", "RBH_USERS_REQ", "")
    
    --join comm channels
    elseif cmd == "join" then        
        RBH_JoinCommChannels()
        
   --help
   elseif cmd == "help" then
      RBH_Help(arg1)    
   else 
      RBH_Help()
   end
end

function RBH_GetAdminLevel()
   if CanEditOfficerNote() and CanEditGuildInfo() then
      return RBH_SUPER_ADMIN
   elseif CanEditOfficerNote() then
      return RBH_ADMIN
   else
      return RBH_USER
   end   
end

function RBH_BuyBounty()
   --local dialog = StaticPopup_Show("ADD_BOUNTY") 
   RBH_AddBountyFrame:Show()
   --[[
   if (dialog) then
      dialog.data  = varName     
      dialog.data2 = varName2
   end  
   local text = _G[dialog:GetName().."Text"];
   local editBox = _G[dialog:GetName().."EditBox"];
   local button1 = _G[dialog:GetName().."Button1"];  
   local moneyInputFrame = _G[dialog:GetName().."MoneyInputFrame"];
   dialog:SetHeight(16 + text:GetHeight() + 8 + editBox:GetHeight() + 8 + button1:GetHeight() + 8 + moneyInputFrame:GetHeight() + 8);   
   ]]--
end

function RBH_Purge()
   local i,n
   i = 1
   if RBH_HitList == nil then
      return
   end
   n = #RBH_HitList
   while (i <= n) do      
      if RBH_HitList[i].audit == 2 and (((RBH_HitList[i].state == "RBH_CLAIMED") and (time() - RBH_HitList[i].timestamp) > RBH_PURGE_AGE_CLAIMED)) or
         (RBH_HitList[i].state == "RBH_DEL" and (time() - RBH_HitList[i].timestamp) > RBH_PURGE_AGE_DEL) then
         table.remove(RBH_HitList,i)
         n = n - 1
         i = i - 1
      end
      i = i + 1
   end
   RBH_HitListUpdate()
end